//
//  Sound.h
//
//  Created by 佐藤 昭 on Thu Jul 18 2002.
//  Copyright (c) 2002 SatoAkira. All rights reserved.
//

#import <AppKit/AppKit.h>
#import "SoundFileWell.h"

#define ASSoundControllerURLKey @"URL"
#define ASSoundDataDidChangeNotification @"ASSoundDataDidChangeNotification"

@interface ASSoundController : NSWindowController <NSWindowDelegate,NSSoundDelegate>
{
	IBOutlet SoundFileWell *soundFileWell;
	IBOutlet NSBox *buttonsBox;
	IBOutlet NSButton *playButton;
	IBOutlet NSButton *stopButton;
	IBOutlet NSButton *pauseButton;
	IBOutlet NSButton *openFileButton;
	IBOutlet NSTextField *playTitleField;
	IBOutlet NSTextField *stopTitleField;
	IBOutlet NSTextField *pauseTitleField;
	NSSound *theSound;
	NSData *soundData;
	NSURL *url;
	BOOL releasedWhenClosed;
}

+ (ASSoundController *)soundController;
+ (ASSoundController *)sharedSoundController;
- (BOOL)setSoundData:(NSData *)aSound;
- (NSData *)soundData;
- (void)setURLWithPath:(NSString *)path;
- (void)setURL:(NSURL *)aValue;
- (void)setSoundDataWithContentsOfURL:(NSURL *)aURL;
- (NSURL *)url;
- (IBAction)openSoundFile:(id)sender;
- (IBAction)playSound:(id)sender;
- (IBAction)stopSound:(id)sender;
- (IBAction)pauseSound:(id)sender;

@end
