// utf-8
//  AddressBookAdaptor.m
//  Enroll
//
//  Created by SatoAkira on Wed Sep 18 2002.
//  Copyright (c) 2002 SatoAkira. All rights reserved.
//

#import "AddressBookAdaptor.h"
#import <AddressBook/AddressBook.h>
#import "EnrollFunctions.h"
#import "MainDocument.h"


@implementation AddressBookAdaptor

+ (AddressBookAdaptor *)adaptor
{
	AddressBookAdaptor *newInstance = [[self alloc] init];
	return newInstance;
}
- (id)init {
	self = [super init];
	return self;
}
- (void)dealloc {
	[super dealloc];
}

- (ABPerson *)changePerson:(ABPerson *)aPerson enroll:(NSDictionary *)aDic image:(NSData *)tiffData at:(NSString *)index
{
	id anObject,anObject2;
	NSMutableDictionary *mDic = nil;
	NSInteger primaryIndex;
	NSString *identifier;
	NSString *tempStr;
	NSCharacterSet *commaAndWhitespaceSet = [NSCharacterSet characterSetWithCharactersInString:@" ,\n\t\r\t"];

	ABAddressBook* tempBook = [ABAddressBook addressBook];
	if (nil == tempBook)
		NSLog(@"tempBook is nil");
	// for (id item in someDataStructure) {
		ABPerson* person = [[ABPerson alloc] initWithAddressBook:tempBook];
	if (nil != person)
		NSLog(@"person OK");
	else
		NSLog(@"person is nil");
	
	if (nil == aPerson) {
		// aPerson = [[[ABPerson alloc] init] autorelease];
		aPerson = [[ABPerson alloc] init];
		if (nil != aPerson)
			NSLog(@"aPerson OK");
		else
			NSLog(@"aPerson is nil");
	}
	else {
		NSString *oldLastName = [aPerson valueForProperty:kABLastNameProperty];
		if (nil != oldLastName)
			[aPerson removeValueForProperty:kABLastNameProperty]; // 10.12.1までに付けたふりがなが残ってしまうので、これを無条件に削除する。 //
	}
	if (nil != index)
		[aPerson setValue:index forProperty:kABMaidenNameProperty]; // 旧姓。これをキーとして検索してisExistsがどうか判断したあと引数のaPersonがnilになるかどうか決定される。 //
	if (nil != (anObject = [aDic objectForKey:NameKey])) { // 氏名 //
		NSArray *nameItems = [anObject componentsSeparatedByString:@" "];
		if ((nil != nameItems) && (1 < nameItems.count)) {
			[aPerson setValue:nameItems.firstObject forProperty:kABLastNameProperty];
			[aPerson setValue:[anObject substringFromIndex:[nameItems.firstObject length] + 1] forProperty:kABFirstNameProperty];
		}
		else
			[aPerson setValue:anObject forProperty:kABFirstNameProperty]; // 名 // // CJK圏外の氏名については対応していない。会社のとき、kABOrganizationProperty。 //
	}
	if (nil != (anObject = [aDic objectForKey:NameKanaKey])) { // 氏名のふりがな //
		// [aPerson setValue:anObject forProperty:kABLastNameProperty]; // 姓。日本語環境ではLastNameの次にFirstNameが表示される。10.12.1までは、このことを利用してふりがなを付けてしまって五十音順に並べられるようにしていた。 //
		NSArray *phoneticItems = [anObject componentsSeparatedByString:@" "];
		if ((nil != phoneticItems) && (1 < phoneticItems.count)) {
			[aPerson setValue:phoneticItems.firstObject forProperty:kABLastNamePhoneticProperty];
			[aPerson setValue:[anObject substringFromIndex:[phoneticItems.firstObject length] + 1] forProperty:kABFirstNamePhoneticProperty];
		}
		else {
			if (nil != [aPerson valueForProperty:kABLastNameProperty]) {
				[aPerson setValue:anObject forProperty:kABLastNamePhoneticProperty]; // kABLastNamePropertyがnilでなければkABFirstNamePhoneticPropertyは無視されて五十音順に並べられなくなる。この為にPhoneticPropertyはkABLastNamePropertyを設定した後で処理しなければならない。 //
				if (nil != [aPerson valueForProperty:kABFirstNamePhoneticProperty])
					[aPerson removeValueForProperty:kABFirstNamePhoneticProperty]; // この場合にkABFirstNamePhoneticPropertyは邪魔なので削除する。 //
			}
			else
				[aPerson setValue:anObject forProperty:kABFirstNamePhoneticProperty]; // 10.12.2から変更した。名のふりがな。kABLastNamePhoneticPropertyも使える。会社のときは, kABOrganizationPhoneticPropertyも使える。 //
		}
	}
	if (nil != (anObject = [aDic objectForKey:PostKey])) // 所属部署 //
		[aPerson setValue:anObject forProperty:kABJobTitleProperty]; // 役職 //
	else {
		if (nil != [aPerson valueForProperty:kABJobTitleProperty])
			[aPerson removeValueForProperty:kABJobTitleProperty];
	}
	ABMutableMultiValue *mValue = [[aPerson valueForProperty:kABAddressProperty] mutableCopy]; // multi-dictionary //
	if (nil == mValue)
		mDic = [[NSMutableDictionary alloc] initWithCapacity:10];
	else {
		primaryIndex = [mValue indexForIdentifier:[mValue primaryIdentifier]];
		mDic = [[mValue valueAtIndex:primaryIndex] mutableCopy];
	}
	if (nil != (anObject = [aDic objectForKey:CountryKey])) {
		[mDic setObject:anObject forKey:kABAddressCountryKey];
		if (nil != (anObject2 = [countryCodeDic() objectForKey:anObject]))
			[mDic setObject:anObject2 forKey:kABAddressCountryCodeKey];
	}
	if (nil != (anObject = [aDic objectForKey:PrefectureKey]))
		[mDic setObject:anObject forKey:kABAddressStateKey];
	if (nil != (anObject = [aDic objectForKey:CityKey]))
		[mDic setObject:anObject forKey:kABAddressCityKey];
	if (nil != (anObject = [aDic objectForKey:TownKey])) {
		if (nil != (anObject2 = [aDic objectForKey:AddressKey]))
			[mDic setObject:[anObject stringByAppendingString:anObject2] forKey:kABAddressStreetKey];
		else
			[mDic setObject:anObject forKey:kABAddressStreetKey];
	}
	else {
		if (nil != (anObject = [aDic objectForKey:AddressKey]))
			[mDic setObject:anObject forKey:kABAddressStreetKey];
	}
	if (nil != (anObject = [aDic objectForKey:ZipKey]))
		[mDic setObject:anObject forKey:kABAddressZIPKey];
	if (nil == mValue) {
		mValue = [[ABMutableMultiValue alloc] init];
		if (nil != (identifier = [mValue addValue:mDic withLabel:kABAddressWorkLabel]))
			[mValue setPrimaryIdentifier:identifier];
		[aPerson setValue:mValue forProperty:kABAddressProperty];
	}
	else {
		[mValue replaceValueAtIndex:primaryIndex withValue:mDic];
		[aPerson setValue:mValue forProperty:kABAddressProperty];
	}
	[mValue release];
	[mDic release];
	if (nil != (anObject = [aDic objectForKey:TelNumberKey])) {
		NSUInteger pCount;
		NSString *pLabel;
		NSString *workPhone = nil;
		NSString *homePhone = nil;
		NSString *mainPhone = nil;
		ABMutableMultiValue *telNumber;

		NSScanner *aScanner = [NSScanner scannerWithString:anObject];
		if (YES == [aScanner scanUpToCharactersFromSet:commaAndWhitespaceSet intoString:&tempStr]) {
			[aScanner scanCharactersFromSet:commaAndWhitespaceSet intoString:NULL];
			workPhone = [NSString stringWithString:tempStr];
		}
		if (YES == [aScanner scanUpToCharactersFromSet:commaAndWhitespaceSet intoString:&tempStr]) {
			[aScanner scanCharactersFromSet:commaAndWhitespaceSet intoString:NULL];
			homePhone = [NSString stringWithString:tempStr];
		}
		if (YES == [aScanner scanUpToCharactersFromSet:commaAndWhitespaceSet intoString:&tempStr]) {
			[aScanner scanCharactersFromSet:commaAndWhitespaceSet intoString:NULL];
			mainPhone = [NSString stringWithString:tempStr];
		}
		if (nil == (telNumber = [[aPerson valueForProperty:kABPhoneProperty] mutableCopy])) // multi-string //
			telNumber = [[ABMutableMultiValue alloc] init];
		if (nil != workPhone) {
			for (pCount = 0; pCount < [telNumber count]; pCount++) {
				pLabel = [telNumber labelAtIndex:pCount];
				if (YES == [pLabel isEqualToString:kABPhoneWorkLabel]) {
					[telNumber replaceValueAtIndex:pCount withValue:workPhone];
					break;
				}
			}
			if ([telNumber count] <= pCount) {
				if (nil != (identifier = [telNumber addValue:workPhone withLabel:kABPhoneWorkLabel]))
					[telNumber setPrimaryIdentifier:identifier];
			}
		}
		if (nil != homePhone) {
			for (pCount = 0; pCount < [telNumber count]; pCount++) {
				pLabel = [telNumber labelAtIndex:pCount];
				if (YES == [pLabel isEqualToString:kABPhoneHomeLabel]) {
					[telNumber replaceValueAtIndex:pCount withValue:homePhone];
					break;
				}
			}
			if ([telNumber count] <= pCount)
				[telNumber addValue:homePhone withLabel:kABPhoneHomeLabel];
		}
		if (nil != mainPhone) {
			for (pCount = 0; pCount < [telNumber count]; pCount++) {
				pLabel = [telNumber labelAtIndex:pCount];
				if (YES == [pLabel isEqualToString:kABPhoneMainLabel]) {
					[telNumber replaceValueAtIndex:pCount withValue:mainPhone];
					break;
				}
			}
			if ([telNumber count] <= pCount)
				[telNumber addValue:mainPhone withLabel:kABPhoneMainLabel];
		}
		[aPerson setValue:telNumber forProperty:kABPhoneProperty];
		[telNumber release];
	}
	if (nil != (anObject = [aDic objectForKey:FaxNumberKey])) {
		NSUInteger fCount;
		NSString *fLabel;
		NSString *workFax = nil;
		NSString *homeFax = nil;
		ABMutableMultiValue *faxNumber;

		NSScanner *aScanner = [NSScanner scannerWithString:anObject];
		if (YES == [aScanner scanUpToCharactersFromSet:commaAndWhitespaceSet intoString:&tempStr]) {
			[aScanner scanCharactersFromSet:commaAndWhitespaceSet intoString:NULL];
			workFax = [NSString stringWithString:tempStr];
		}
		if ((NO == [aScanner isAtEnd]) && (YES == [aScanner scanUpToCharactersFromSet:commaAndWhitespaceSet intoString:&tempStr])) {
			[aScanner scanCharactersFromSet:commaAndWhitespaceSet intoString:NULL];
			homeFax = [NSString stringWithString:tempStr];
		}
		if (nil == (faxNumber= [[aPerson valueForProperty:kABPhoneProperty] mutableCopy])) // multi-string //
			faxNumber = [[ABMutableMultiValue alloc] init];
		if (nil != faxNumber) {
			if (nil != workFax) {
				for (fCount = 0; fCount < [faxNumber count]; fCount++) {
					fLabel = [faxNumber labelAtIndex:fCount];
					if (YES == [fLabel isEqualToString:kABPhoneWorkFAXLabel]) {
						[faxNumber replaceValueAtIndex:fCount withValue:workFax];
						break;
					}
				}
				if ([faxNumber count] <= fCount)
					[faxNumber addValue:workFax withLabel:kABPhoneWorkFAXLabel];
			}
			if (nil != homeFax) {
				for (fCount = 0; fCount < [faxNumber count]; fCount++) {
					fLabel = [faxNumber labelAtIndex:fCount];
					if (YES == [fLabel isEqualToString:kABPhoneHomeFAXLabel]) {
						[faxNumber replaceValueAtIndex:fCount withValue:homeFax];
						break;
					}
				}
				if ([faxNumber count] <= fCount)
					[faxNumber addValue:homeFax withLabel:kABPhoneHomeFAXLabel];
			}
			[aPerson setValue:faxNumber forProperty:kABPhoneProperty];
			[faxNumber release];
		}
	}
	if (nil != (anObject = [aDic objectForKey:PHSNumberKey])) {
		NSUInteger phsCount;
		NSString *phsLabel;
		NSString *workPhs = nil;
		NSString *homePhs = nil;
		ABMutableMultiValue *phsNumber;

		NSScanner *aScanner = [NSScanner scannerWithString:anObject];
		if (YES == [aScanner scanUpToCharactersFromSet:commaAndWhitespaceSet intoString:&tempStr]) {
			[aScanner scanCharactersFromSet:commaAndWhitespaceSet intoString:NULL];
			workPhs = [NSString stringWithString:tempStr];
		}
		if ((NO == [aScanner isAtEnd]) && (YES == [aScanner scanUpToCharactersFromSet:commaAndWhitespaceSet intoString:&tempStr])) {
			[aScanner scanCharactersFromSet:commaAndWhitespaceSet intoString:NULL];
			homePhs = [NSString stringWithString:tempStr];
		}
		if (nil == (phsNumber = [[aPerson valueForProperty:kABPhoneProperty] mutableCopy])) // multi-string //
			phsNumber = [[ABMutableMultiValue alloc] init];
		if ((nil != workPhs) && (nil != phsNumber)) {
			for (phsCount = 0; phsCount < [phsNumber count]; phsCount++) {
				phsLabel = [phsNumber labelAtIndex:phsCount];
				if (YES == [phsLabel isEqualToString:kABPhoneMobileLabel]) {
					[phsNumber replaceValueAtIndex:phsCount withValue:workPhs];
					break;
				}
			}
			if ([phsNumber count] <= phsCount)
				[phsNumber addValue:workPhs withLabel:kABPhoneMobileLabel];
		}
		if ((nil != homePhs) && (nil != phsNumber)) {
			for (phsCount = 0; phsCount < [phsNumber count]; phsCount++) {
				phsLabel = [phsNumber labelAtIndex:phsCount];
				if (YES == [phsLabel isEqualToString:kABPhonePagerLabel]) {
					[phsNumber replaceValueAtIndex:phsCount withValue:homePhs];
					break;
				}
			}
			if ([phsNumber count] <= phsCount)
				[phsNumber addValue:homePhs withLabel:kABPhonePagerLabel];
		}
		[aPerson setValue:phsNumber forProperty:kABPhoneProperty];
		[phsNumber release];
	}
	if ((nil != (anObject = [aDic objectForKey:EmailKey])) && (0 < [anObject count])) {
		NSUInteger eCount;
		NSString *eLabel;
		ABMutableMultiValue *emailValue;

		if (nil == (emailValue = [[aPerson valueForProperty:kABEmailProperty] mutableCopy])) // multi-string //
			emailValue = [[ABMutableMultiValue alloc] init];
		if (nil != emailValue) {
			for (eCount = 0; eCount < [emailValue count]; eCount++) {
				eLabel = [emailValue labelAtIndex:eCount];
				if (YES == [eLabel isEqualToString:kABEmailWorkLabel]) {
					[emailValue replaceValueAtIndex:eCount withValue:[anObject firstObject]];
					break;
				}
			}
			if ([emailValue count] <= eCount) {
				if (nil != (identifier = [emailValue addValue:[anObject firstObject] withLabel:kABEmailWorkLabel]))
					[emailValue setPrimaryIdentifier:identifier];
			}
			if (1 < [anObject count]) {
				for (eCount = 0; eCount < emailValue.count; eCount++) {
					eLabel = [emailValue labelAtIndex:eCount];
					if (YES == [eLabel isEqualToString:kABEmailHomeLabel]) {
						[emailValue replaceValueAtIndex:eCount withValue:[anObject objectAtIndex:1]];
						break;
					}
				}
				if ([emailValue count] <= eCount)
					[emailValue addValue:[anObject objectAtIndex:1] withLabel:kABEmailHomeLabel];
			}
			[aPerson setValue:emailValue forProperty:kABEmailProperty];
			[emailValue release];
		}
	}
	else {
		if (nil != [aPerson valueForProperty:kABEmailProperty])
			[aPerson removeValueForProperty:kABEmailProperty];
	}
	if ((nil != (anObject = [aDic objectForKey:URLNameKey])) && (0 < [anObject count]))
		[aPerson setValue:[anObject objectAtIndex:0] forProperty:kABHomePageProperty];
	else {
		if (nil != [aPerson valueForProperty:kABHomePageProperty])
			[aPerson removeValueForProperty:kABHomePageProperty];
	}
	if (nil != (anObject = [aDic objectForKey:TypeKey]))
		[aPerson setValue:anObject forProperty:kABOrganizationProperty];
	else {
		if (nil != [aPerson valueForProperty:kABOrganizationProperty])
			[aPerson removeValueForProperty:kABOrganizationProperty];
	}
    if (nil != (anObject = [aDic objectForKey:BirthDayKey])) {
#if MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_10
        NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
        [formatter setFormatterBehavior:NSDateFormatterBehavior10_4];
        [formatter setDateFormat:@"yyyy-MM-dd"];
        [aPerson setValue:[formatter dateFromString:anObject] forProperty:kABBirthdayProperty]; // This property is an NSDate object. //
        [formatter release];
#else
		[aPerson setValue:[NSCalendarDate dateWithString:anObject calendarFormat:@"%Y-%m-%d"] forProperty:kABBirthdayProperty];
#endif
    }
	else {
		if (nil != [aPerson valueForProperty:kABBirthdayProperty])
			[aPerson removeValueForProperty:kABBirthdayProperty];
	}
	if (nil != (anObject = [aDic objectForKey:OthersKey]))
		[aPerson setValue:anObject forProperty:kABNoteProperty];
	else {
		if (nil != [aPerson valueForProperty:kABNoteProperty])
			[aPerson removeValueForProperty:kABNoteProperty];
	}
	if (nil != tiffData)
		[aPerson setImageData:tiffData];
	return aPerson;
}

- (NSData *)vCardRepresentation:(NSDictionary *)aDic image:(NSData *)tiffData at:(NSString *)index {
	return (nil != aDic) ? [[self changePerson:nil enroll:aDic image:tiffData at:index] vCardRepresentation] : nil;
}

- (BOOL)isExistsAtAddressBook:(NSString *)index
{
	ABAddressBook *AB = [ABAddressBook sharedAddressBook];
	ABSearchElement *maidenSearch = [ABPerson searchElementForProperty:kABMaidenNameProperty label:nil key:nil value:index comparison:kABEqual];
	NSArray *peopleFound = [AB recordsMatchingSearchElement:maidenSearch];

	return ((nil != peopleFound) && (0 < [peopleFound count])) ? YES : NO;
}

- (BOOL)saveAperson:(NSDictionary *)aDic image:(NSData *)tiffData at:(NSString *)index
{
	ABAddressBook *AB = [ABAddressBook sharedAddressBook];
	if (YES == [self isExistsAtAddressBook:index]) {
		ABSearchElement *maidenSearch = [ABPerson searchElementForProperty:kABMaidenNameProperty label:nil key:nil value:index comparison:kABEqual];
		NSArray *peopleFound = [AB recordsMatchingSearchElement:maidenSearch];

		[self changePerson:[peopleFound firstObject] enroll:aDic image:tiffData at:nil];
		return [AB save];
	}
	else {
		
		ABPerson *newPerson = [self changePerson:nil enroll:aDic image:tiffData at:index];
		if (nil != newPerson)
			NSLog(@"not exists.");
		if (YES == [AB addRecord:newPerson])
			NSLog(@"addRecord OK");
		else
			NSLog(@"addRecord fail");
		return (YES == [AB addRecord:newPerson]) ? [AB save] : NO;
	}
}

- (BOOL)saveAgroup:(NSURL *)source enroll:(NSDictionary *)dic group:(NSString *)groupName images:(NSFileWrapper *)imagesWrapper
{
	NSArray *groups;
	ABAddressBook *AB = [ABAddressBook sharedAddressBook];

	if ((nil == [AB groups]) || (0 == [[AB groups] count])) { /* new */
		ABGroup *newGroup = [[ABGroup alloc] init];

		if (YES == [newGroup setValue:groupName forProperty:kABGroupNameProperty]) {
			if (YES == [AB addRecord:newGroup]) {
				[AB save];
				groups = [AB groups];
			}
			else
				groups = nil;
		}
		else
			groups = nil;
		[newGroup release];
	}
	else
		groups = [AB groups];
	if (nil != groups) {
		BOOL found = NO;
		ABGroup *aGroup = nil;

		for (aGroup in groups) {
			if (YES == [[aGroup valueForProperty:kABGroupNameProperty] isEqualToString:groupName]) {
				[aGroup retain];
				found = YES;
				break;
			}
		}
		if (NO == found) {
			aGroup = [[ABGroup alloc] init];
			[aGroup setValue:groupName forProperty:kABGroupNameProperty];
			[AB addRecord:aGroup];
			[AB save];
		}
		if (nil != aGroup) {
			NSMutableDictionary *aModel;
			ABSearchElement *maidenSearch;
			NSArray *peopleFound;
			NSData *tiffData,*imageData;
			NSString *imageExtension;
			NSImage *image;
			ABPerson *aPerson;
			NSDictionary *wrappers = (nil != imagesWrapper) ? [imagesWrapper fileWrappers] : nil;

			for (NSString *index in dic) {
				aModel = [dic objectForKey:index];
				imageData = nil;
				imageExtension = nil;
				for (NSString *imageFilename in wrappers) {
					if (YES == [index isEqualToString:[imageFilename stringByDeletingPathExtension]]) {
						imageData = [[wrappers objectForKey:imageFilename] regularFileContents];
						imageExtension = [imageFilename pathExtension];
						break;
					}
				}
				image = (nil != imageData) ? [[NSImage alloc] initWithData:imageData] : nil; // 面倒くさいのでNSImageを使うのだ //
				tiffData = (nil != image) ? [image TIFFRepresentation] : nil;
				if (nil != image)
					[image release];
				if (YES == [self isExistsAtAddressBook:index]) {
					maidenSearch = [ABPerson searchElementForProperty:kABMaidenNameProperty label:nil key:nil value:index comparison:kABEqual];
					peopleFound = [AB recordsMatchingSearchElement:maidenSearch];
					aPerson = [peopleFound objectAtIndex:0];
					[self changePerson:aPerson enroll:aModel image:tiffData at:nil];
					if (NO == [[aPerson parentGroups] containsObject:groupName])
						[aGroup addMember:aPerson];
				}
				else {
					if (nil != (aPerson = [self changePerson:nil enroll:aModel image:tiffData at:index])) {
						[AB addRecord:aPerson]; // dyld: DYLD_ environment variables being ignored because main executable (/System/Library/Frameworks/AddressBook.framework/Resources/AddressBookSync.app/Contents/MacOS/AddressBookSync) is code signed with entitlements //
						[aGroup addMember:aPerson];
					}
				}
			}
			[aGroup release];
			return [AB save];
		}
		else
			return NO;
	}
	else
		return NO;
}

@end
