//
//  EnrollFunctions.m
//  Enroll
//
//  Created by 佐藤 昭 on Tue Jul 16 2002.
//  Copyright (c) 2002 SatoAkira. All rights reserved.
//

#import "EnrollFunctions.h"


@implementation EnrollFunctions

NSString *strntrim(NSString *aString,NSInteger cutLength,BOOL cFlag)
/* cutLengthが0以下のとき、長さの指定が無いものとする。 */
{
	NSUInteger length = [aString length];

	if (0 < length) {
		NSUInteger i;
		NSMutableString *tempString = [NSMutableString stringWithString:aString];
		NSCharacterSet *wsCharSet = [NSCharacterSet whitespaceAndNewlineCharacterSet]; /* 全角スペースも含まれる */

		for (i = 0; i < length && (YES == [wsCharSet characterIsMember:[tempString characterAtIndex:0]]); i++) /* 先頭のスペースを切りながら、tempStringを左詰めにしていく。 */
			[tempString deleteCharactersInRange:NSMakeRange(0,1)];
		if (length > i) {
			NSUInteger j;

			for (length = [tempString length], i = j = 0; i < length; i++) { /* 末尾の空白が連続する位置を捜す。 */
				if (NO == [wsCharSet characterIsMember:[tempString characterAtIndex:i]])
					j = i;
			}
			if (j < length - 1)	/* 末尾の連続した空白を抹消する。 */
				[tempString deleteCharactersInRange:NSMakeRange(j + 1,length - j - 1)];
			/* if (YES == cFlag) {	// ここで、C言語上の長さに合わせる操作をする。 //
				if ((0 < cutLength) && ([tempString cStringLength] > (NSUInteger)cutLength)) {
					char *tempCString = (char *)[tempString cString];

					*(tempCString + cutLength) = '\0';
					tempString = [NSString stringWithCString:tempCString];
				}
			}
			else { */
				if ((0 < cutLength) && ((length = [tempString length]) > (NSUInteger)cutLength))
					[tempString deleteCharactersInRange:NSMakeRange(cutLength,length - cutLength)];
			/* } */
			/* 中間のスペースを削除する。 */
			/* for (length = [tempString length], i = length - 1; i > 0; i--) {
				if (YES == [wsCharSet characterIsMember:[tempString characterAtIndex:i]])
					[tempString deleteCharactersInRange:NSMakeRange(i,1)];
			} */
			return tempString;
		}
		else
			return [NSString string];
	}
	else
		return [NSString string];
}

// NSString *fldate() //
// 返す値は環境設定に関係なくグレゴリオ暦固定である。 //
// 不完全に日付が並べられている文字列dateStringを10桁の定型書式に変換して、その文字列を返す。 //
// 日のみの場合、あるいは月日のみの場合にはシステム時刻から年月等を得てそれを加える。 //
// dateStringが空文字(NULLではない)の場合には、システム時刻の日付となる。 //
// "西暦年(4桁)-月(2桁)-日(2桁)"の書式で返す。引数dateStringも右づめでこの並びであることが必要である。 //
// 桁数が不足している場合には、左の方が省略されたものとみなす。 //
// 昔の米国式の"月/日/年"という並びには対応しない。 //
// 文字列dateStringのなかで年号が直接指定されている場合 */
//     1年から79年は2000年を加える。"79-12-31"は"2079-12-31"になる。 //
//     80年から200年は1900年を加える。"1000101"は"2000-01-01"になる。 //
//     201年から9999年はそのまま。"-9999*04*20"は"9999-04-20"になる。 //
//     従って、紀元前から西暦100年の間は不対応。 //
// 2000年対応。 //
// 使い方の例は以下 //
// Objective-C の場合 //
//	[textField setStringValue:fldate([sender stringValue])]; //
#if MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_10
NSString *fldate(NSString *dateString)
{
    if (nil != dateString) {
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian]; // 環境設定に関係なくグレゴリオ暦にしなければならない。 //
        NSDateComponents *components = [calendar components:NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay fromDate:[NSDate date]]; // NSCalendar.hに定義されている値。 //
        NSInteger yy = [components year];
        NSInteger mo = [components month];
        NSInteger dd = [components day];
        NSString *inputStr = strntrim(dateString,0,NO);
        
        if (NO == [inputStr isEqualToString:@""]) {
            NSUInteger i = 0;
            NSCharacterSet *nonDecimalSet = [[NSCharacterSet decimalDigitCharacterSet] invertedSet];
            NSScanner *aScanner = [NSScanner scannerWithString:inputStr];
            NSInteger *tempInt = (NSInteger *)malloc(3 * sizeof(NSInteger));
            
            [aScanner setCharactersToBeSkipped:nonDecimalSet];
            while (NO == [aScanner isAtEnd]) {
                [aScanner scanInteger:tempInt];
                tempInt++;
                i++;
                if (3 == i)
                    break;
            }
            tempInt -= i;
            switch (i) {
                case 3:
                    yy = *tempInt;
                    mo = *(tempInt + 1);
                    dd = *(tempInt + 2);
                    break;
                case 2:
                    mo = *tempInt;
                    dd = *(tempInt + 1);
                    break;
                case 1:
                    dd = *tempInt;
                    break;
                default: // [NSDate date] の日付になる //
                    break;
            }
            if (10000 < dd) {
                yy = dd / 10000;
                mo = (dd % 10000) / 100;
                dd %= 100;
            }
            else {
                if (100 < dd) {
                    if (1 < i)
                        yy = mo;
                    mo = dd / 100;
                    dd %= 100;
                }
            }
            if (31 < dd) {
                mo = dd / 10;
                dd %= 10;
            }
            if (100 < mo) {
                yy = mo / 100;
                mo %= 100;
            }
            if (12 < mo) {
                yy = mo / 10;
                mo %= 10;
            }
            if (200 >= yy)
                yy += (80 <= yy) ? 1900 : 2000;
            free(tempInt);
            [components setYear:yy];
            [components setMonth:mo];
            [components setDay:dd];
        }
        NSDateFormatter *fldateFormatter = [[NSDateFormatter alloc] init];
        [fldateFormatter setFormatterBehavior:NSDateFormatterBehavior10_4];
        [fldateFormatter setCalendar:calendar];
        [fldateFormatter setDateFormat:@"yyyy-MM-dd"]; // 2010-02-09 という書式にする。 //
        NSString *rStr = [fldateFormatter stringFromDate:[calendar dateFromComponents:components]];
        [fldateFormatter release];
        [calendar release];
        return rStr;
    }
    else
        return nil;
}
#elif MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_4
NSString *fldate(NSString *dateString)
{
    if (nil != dateString) {
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar]; // 環境設定に関係なくグレゴリオ暦にしなければならない。 //
        NSDateComponents *components = [calendar components:NSYearCalendarUnit | NSMonthCalendarUnit | NSDayCalendarUnit fromDate:[NSDate date]];// NSLocaleに定義されている値。 //
        NSInteger yy = [components year];
        NSInteger mo = [components month];
        NSInteger dd = [components day];
        NSString *inputStr = strntrim(dateString,0,NO);
        
        if (NO == [inputStr isEqualToString:@""]) {
            NSUInteger i = 0;
            NSCharacterSet *nonDecimalSet = [[NSCharacterSet decimalDigitCharacterSet] invertedSet];
            NSScanner *aScanner = [NSScanner scannerWithString:inputStr];
            NSInteger *tempInt = (NSInteger *)malloc(3 * sizeof(NSInteger));
            
            [aScanner setCharactersToBeSkipped:nonDecimalSet];
            while (NO == [aScanner isAtEnd]) {
                [aScanner scanInteger:tempInt];
                tempInt++;
                i++;
                if (3 == i)
                    break;
            }
            tempInt -= i;
            switch (i) {
                case 3:
                    yy = *tempInt;
                    mo = *(tempInt + 1);
                    dd = *(tempInt + 2);
                    break;
                case 2:
                    mo = *tempInt;
                    dd = *(tempInt + 1);
                    break;
                case 1:
                    dd = *tempInt;
                    break;
                default: // [NSDate date] の日付になる //
                    break;
            }
            if (10000 < dd) {
                yy = dd / 10000;
                mo = (dd % 10000) / 100;
                dd %= 100;
            }
            else {
                if (100 < dd) {
                    if (1 < i)
                        yy = mo;
                    mo = dd / 100;
                    dd %= 100;
                }
            }
            if (31 < dd) {
                mo = dd / 10;
                dd %= 10;
            }
            if (100 < mo) {
                yy = mo / 100;
                mo %= 100;
            }
            if (12 < mo) {
                yy = mo / 10;
                mo %= 10;
            }
            if (200 >= yy)
                yy += (80 <= yy) ? 1900 : 2000;
            free(tempInt);
            [components setYear:yy];
            [components setMonth:mo];
            [components setDay:dd];
        }
        NSDateFormatter *fldateFormatter = [[NSDateFormatter alloc] init];
        [fldateFormatter setFormatterBehavior:NSDateFormatterBehavior10_4];
        [fldateFormatter setCalendar:calendar];
        [fldateFormatter setDateFormat:@"yyyy-MM-dd"]; // 2010-02-09 という書式にする。 //
        NSString *rStr = [fldateFormatter stringFromDate:[calendar dateFromComponents:components]];
        [fldateFormatter release];
        [calendar release];
        return rStr;
    }
    else
        return nil;
}
#else
NSString *fldate(NSString *dateString)
{
    if (nil != dateString) {
        NSCalendarDate *today = [[NSDate date] dateWithCalendarFormat:nil timeZone:nil];
        NSInteger yy = [today yearOfCommonEra];
        NSInteger mo = [today monthOfYear];
        NSInteger dd = [today dayOfMonth];
        NSString *inputStr = strntrim(dateString,0,NO);
        
        if (NO == [inputStr isEqualToString:@""]) {
            NSUInteger i = 0;
            NSCharacterSet *nonDecimalSet = [[NSCharacterSet decimalDigitCharacterSet] invertedSet];
            NSScanner *aScanner = [NSScanner scannerWithString:inputStr];
            NSInteger *tempInt = (NSInteger *)malloc(3 * sizeof(NSInteger));
            
            [aScanner setCharactersToBeSkipped:nonDecimalSet];
            while (NO == [aScanner isAtEnd]) {
                [aScanner scanInteger:tempInt];
                tempInt++;
                i++;
                if (3 == i)
                    break;
            }
            tempInt -= i;
            switch (i) {
                case 3:
                    yy = *tempInt;
                    mo = *(tempInt + 1);
                    dd = *(tempInt + 2);
                    break;
                case 2:
                    mo = *tempInt;
                    dd = *(tempInt + 1);
                    break;
                case 1:
                    dd = *tempInt;
                    break;
                default: // [NSDate date] の日付になる //
                    break;
            }
            if (10000 < dd) {
                yy = dd / 10000;
                mo = (dd % 10000) / 100;
                dd %= 100;
            }
            else {
                if (100 < dd) {
                    if (1 < i)
                        yy = mo;
                    mo = dd / 100;
                    dd %= 100;
                }
            }
            if (31 < dd) {
                mo = dd / 10;
                dd %= 10;
            }
            if (100 < mo) {
                yy = mo / 100;
                mo %= 100;
            }
            if (12 < mo) {
                yy = mo / 10;
                mo %= 10;
            }
            if (200 >= yy)
                yy += (80 <= yy) ? 1900 : 2000;
            free(tempInt);
        }
        return [[NSCalendarDate dateWithYear:yy month:mo day:dd hour:0 minute:0 second:0 timeZone:[NSTimeZone localTimeZone]] descriptionWithCalendarFormat:@"%Y-%m-%d"];
    }
    else
        return nil;
}
#endif

NSDictionary *countryCodeDic(void)
{
	return [NSDictionary dictionaryWithObjectsAndKeys:@"at",NSLocalizedString(@"Austria",@""),@"au",NSLocalizedString(@"Australia",@""),
@"be",NSLocalizedString(@"Belgium",@""),@"ca",NSLocalizedString(@"Canada",@""),@"ch",NSLocalizedString(@"Switzerland",@""),@"cn",NSLocalizedString(@"China",@""),@"de",NSLocalizedString(@"Germany",@""),@"dk",NSLocalizedString(@"Denmark",@""),@"es",NSLocalizedString(@"Spain",@""),@"fi",NSLocalizedString(@"Finland",@""),@"fr",NSLocalizedString(@"France",@""),@"gl",NSLocalizedString(@"Greenland",@""),@"ie",NSLocalizedString(@"Ireland",@""),@"il",NSLocalizedString(@"Israel",@""),@"id",NSLocalizedString(@"Indonesia",@""),@"is",NSLocalizedString(@"Iceland",@""),@"it",NSLocalizedString(@"Italy",@""),@"ja",NSLocalizedString(@"Japan",@""),@"kr",NSLocalizedString(@"South Korea",@""),@"lu",NSLocalizedString(@"Luxembourg",@""),@"mx",NSLocalizedString(@"Mexico",@""),@"nl",NSLocalizedString(@"Netherlands",@""),@"no",NSLocalizedString(@"Norway",@""),@"nz",NSLocalizedString(@"New Zealand",@""),@"pl",NSLocalizedString(@"Poland",@""),@"pt",NSLocalizedString(@"Portugal",@""),@"se",NSLocalizedString(@"Sweden",@""),@"sg",NSLocalizedString(@"Singapore",@""),@"tr",NSLocalizedString(@"Turkey",@""),@"tw",NSLocalizedString(@"Taiwan",@""),@"uk",NSLocalizedString(@"United Kingdom",@""),@"us",NSLocalizedString(@"United States",@""),@"za",NSLocalizedString(@"South Africa",@""),nil];
}

@end
