/* HtmlFileAdaptor.m created by SatoAkira on Sat 26-Jun-1999 */

#import "HtmlFileAdaptor.h"
#ifndef __APPLE__
#import <SoundKit/Sound.h>
#endif
#import "MainDocument.h" /* 2002-07-16 追加 */


@implementation HtmlFileAdaptor

- (id)init;
{
	self = [super init];
	return self;
}

- (void)dealloc;
{
	[super dealloc];
}

- (BOOL)write:(NSDictionary *)aDic toFile:(NSString *)path atomically:(BOOL)flag
{
	BOOL isDir;
	NSFileManager *manager = [NSFileManager defaultManager];

	if ((NO == [manager fileExistsAtPath:path isDirectory:&isDir]) || (NO == isDir) || (YES == [manager isWritableFileAtPath:path])) {
		NSString *index;
		NSString *rootIndex;
		NSString *name;
		NSString *nameKana;
		NSString *post;
		NSString *country;
		NSString *zip;
		NSString *prefecture;
		NSString *city;
		NSString *town;
		NSString *address;
		NSString *prefectureKana;
		NSString *cityKana;
		NSString *townKana;
		NSString *telNumber;
		NSString *faxNumber;
		NSString *phsNumber;
		NSString *email;
		NSString *url;
		NSString *type;
		NSString *birthDay;
		NSString *others;
		double locateX;
		double locateY;
		double locateZ;
		NSImage *picture;
		NSString *pictureFilename;
#ifdef __APPLE__
		NSData *sound;
#else
		Sound *sound;
#endif
		Model *aModel;
		NSUInteger i,j;
		NSString *soundFilename,*imageFilename,*file,*soundFile;
		NSArray *dirContents;
		NSUInteger count = [aDic count];
		NSArray *keysArray = [[aDic allKeys] sortedArrayUsingSelector:@selector(compare:)];
		NSMutableString *writeString = [NSMutableString string];
		NSString *trashFilename = [path stringByAppendingPathComponent:@"images/.trash"];
#ifdef __APPLE__
		NSArray *soundFileTypes = [NSSound soundUnfilteredFileTypes];
#endif

		if ((NO == [manager fileExistsAtPath:path isDirectory:&isDir]) && (NO == [manager createDirectoryAtPath:path attributes:nil])) {
			return NO;
		}
		if (YES == [manager fileExistsAtPath:trashFilename]) {
			NSString *removeFilename;
			NSScanner *tScanner = [NSScanner scannerWithString:[NSString stringWithContentsOfFile:trashFilename]];
			NSCharacterSet *spaceSet = [NSCharacterSet characterSetWithCharactersInString:@" "];
			NSString *tabString = @"\t";

			[tScanner setCharactersToBeSkipped:spaceSet];
			while (NO == [tScanner isAtEnd]) {
				[tScanner scanUpToString:tabString intoString:&removeFilename];
				[tScanner scanString:tabString intoString:NULL];
				[manager removeFileAtPath:[path stringByAppendingPathComponent:removeFilename] handler:nil];
			}
			[manager removeFileAtPath:trashFilename handler:nil];
		}
		if (NO == [manager fileExistsAtPath:[trashFilename stringByDeletingLastPathComponent]])
			[manager createDirectoryAtPath:[trashFilename stringByDeletingLastPathComponent] attributes:nil];
		[writeString appendFormat:@"<HTML>\n<HEAD>\n<TITLE>%@</TITLE>\n</HEAD>\n<BODY>\n",[[path lastPathComponent] stringByDeletingPathExtension]];
		/* [writeString appendFormat:@"<HTML>\n<HEAD>\n<META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\"\n<TITLE>%@</TITLE>\n</HEAD>\n<BODY>\n",[[path lastPathComponent] stringByDeletingPathExtension]]; */ /* シフトJISは[Shift_JIS],UTF-8は[utf-8],ISO-8859-1(ASCII)は[iso-8859-1],EUCは[euc-jp], */
		for (i = 0; i < count; i++) {
			aModel = [aDic objectForKey:[keysArray objectAtIndex:i]];
			index = [aModel index];
			rootIndex = [aModel rootIndex];
			name = [aModel name];
			nameKana = [aModel nameKana];
			post = [aModel post];
			country = [aModel country];
			zip = [aModel zip];
			prefecture = [aModel prefecture];
			city = [aModel city];
			town = [aModel town];
			address = [aModel address];
			prefectureKana = [aModel prefectureKana];
			cityKana = [aModel cityKana];
			townKana = [aModel townKana];
			telNumber = [aModel telNumber];
			faxNumber = [aModel faxNumber];
			phsNumber = [aModel phsNumber];
			email = [aModel email];
			url = [aModel url];
			type = [aModel type];
			birthDay = [aModel birthDay];
			others = [aModel others];
			locateX = [aModel locateX];
			locateY = [aModel locateY];
			locateZ = [aModel locateZ];
#ifdef __APPLE__
			[writeString appendFormat:@"%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t",index,rootIndex,name,nameKana,post,country,zip,prefecture,city,town,address,prefectureKana,cityKana,townKana,telNumber,faxNumber,phsNumber,email,url,type];
			[writeString appendFormat:@"%@\t%@\t%g\t%g\t%g\t",birthDay,others,locateX,locateY,locateZ];
#else
			[writeString appendFormat:@"%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%@\t%g\t%g\t%g\t",index,rootIndex,name,nameKana,post,country,zip,prefecture,city,town,address,prefectureKana,cityKana,townKana,telNumber,faxNumber,phsNumber,email,url,type,birthDay,others,locateX,locateY,locateZ];
#endif

			pictureFilename = [aModel pictureFilename];
			dirContents = [manager directoryContentsAtPath:path];
			if (((nil != [aModel picture]) && (YES == [pictureFilename hasPrefix:@"/"])) || (nil == [aModel picture])) { /* 画像ファイルに変更があったか否かを、絶対パスかどうかで判断する。画像がなくなってしまった場合はnilであることで判断する。 */
				for (j = 0; j < [dirContents count]; j++) {
					file = [dirContents objectAtIndex:j];
#ifdef __APPLE__
					if ((YES == [[file stringByDeletingPathExtension] isEqualToString:index]) && (NO == [soundFileTypes containsObject:[file pathExtension]])) {
#else
					if ((YES == [[file stringByDeletingPathExtension] isEqualToString:index]) && (NO == [[file pathExtension] isEqualToString:@"snd"])) {
#endif
						[manager removeFileAtPath:[path stringByAppendingPathComponent:file] handler:nil];
						break;
					}
				}
			}
			if ((nil != (picture = [aModel picture])) && (NO == [pictureFilename isEqualToString:@""])) {
				imageFilename = [index stringByAppendingPathExtension:[pictureFilename pathExtension]];
				if (YES == [pictureFilename hasPrefix:@"/"]) {
					if (YES == [manager copyPath:pictureFilename toPath:[path stringByAppendingPathComponent:imageFilename] handler:nil]) {
						[aModel setPictureFilename:imageFilename];
						[writeString appendFormat:@"<IMG SRC=\"%@\">",imageFilename];
					}
				}
				else {
					if ((NO == [manager fileExistsAtPath:[path stringByAppendingPathComponent:imageFilename]]) && (YES == [manager copyPath:imageFilename toPath:[path stringByAppendingPathComponent:imageFilename] handler:nil]))
						[writeString appendFormat:@"<IMG SRC=\"%@\">",imageFilename];
					else
						[writeString appendFormat:@"<IMG SRC=\"%@\">",imageFilename];
				}
			}

#ifdef __APPLE__
			soundFilename = [aModel soundFilename];
			if (((nil != (sound = [aModel sound])) && (0 < [sound length]) && (YES == [soundFilename hasPrefix:@"/"])) || (nil == sound) || (0 == [sound length])) { /* 音声ファイルに変更があったか否かを、絶対パスかどうかで判断する。音声がなくなってしまった場合はnilであることで判断する。 */
				for (j = 0; j < [dirContents count]; j++) {
					file = [dirContents objectAtIndex:j];
					if ((YES == [[file stringByDeletingPathExtension] isEqualToString:index]) && (YES == [soundFileTypes containsObject:[file pathExtension]])) {
						[manager removeFileAtPath:[path stringByAppendingPathComponent:file] handler:nil];
						break;
					}
				}
			}
			if ((nil != (sound = [aModel sound])) && (0 < [sound length]) && (NO == [soundFilename isEqualToString:@""])) {
				soundFile = [index stringByAppendingPathExtension:[soundFilename pathExtension]];
				if (YES == [soundFilename hasPrefix:@"/"]) {
					if (YES == [manager copyPath:soundFilename toPath:[path stringByAppendingPathComponent:soundFile] handler:nil]) {
						[aModel setSoundFilename:soundFile];
						[writeString appendFormat:@"<A HREF=\"%@\"><IMG SRC=\"images/lips.png\"></A>",soundFile];
					}
				}
				else {
					if ((NO == [manager fileExistsAtPath:[path stringByAppendingPathComponent:soundFile]]) && (YES == [manager copyPath:soundFile toPath:[path stringByAppendingPathComponent:soundFile] handler:nil]))
						[writeString appendFormat:@"<A HREF=\"%@\"><IMG SRC=\"images/lips.png\"></A>",soundFile];
					else
						[writeString appendFormat:@"<A HREF=\"%@\"><IMG SRC=\"images/lips.png\"></A>",soundFile];
				}
			}
#else
			soundFilename = [index stringByAppendingPathExtension:@"snd"];
			if ((nil !=  (sound = [aModel sound])) && (NO == [sound isEmpty])) { /* ファイルへwriteSoundfile:するときにsound data の2000h以下が0に化けてしまうことがある。化けるときが不定の為、原因を特定できない。copySound:,convertToFormat:, setSoundStruct:でも駄目。何故だか分からない。 */
				if (YES == [sound needsCompacting]) {
					[sound compactSamples];
					NSLog(@"HtmlFileAdaptor:sound compactSamples.");
				}
				/* このif elseはController.mのsetModel:でsndファイルが作られた場合のみ正しく動作する。sndファイルが作られない場合はsndファイルの有無に係わらずwriteSoundfile:を実行しなければならない。 */
				if (NO == [manager fileExistsAtPath:[path stringByAppendingPathComponent:soundFilename]]) {
					if (SND_ERR_NONE == [sound writeSoundfile:[path stringByAppendingPathComponent:soundFilename]])
						[writeString appendFormat:@"<A HREF=\"%@\"><IMG SRC=\"images/snd.gif\"></A>",soundFilename];
					else
						NSRunAlertPanel(@"HtmlFileAdaptor",@"Sound could not saved at index:%@",nil,nil,nil,index);
				}
				else
					[writeString appendFormat:@"<A HREF=\"%@\"><IMG SRC=\"images/snd.gif\"></A>",soundFilename];
			}
			else {
				if (YES == [manager fileExistsAtPath:[path stringByAppendingPathComponent:soundFilename]])
					if (NO == [manager removeFileAtPath:[path stringByAppendingPathComponent:soundFilename] handler:nil])
						NSLog(@"HtmlFileAdaptor:Sound file remove error.");
				soundFilename = @"";
			}
#endif

			[writeString appendString:@"<BR>\n"];
		}
		/* </BODY>の後の\tは重要 */
		[writeString appendString:@"</BODY>\t\n</HTML>\n"];
#ifdef __APPLE__
		[manager copyPath:[[NSBundle bundleForClass:[self class]] pathForResource:@"lips" ofType:@"png"] toPath:[[trashFilename stringByDeletingLastPathComponent] stringByAppendingPathComponent:@"lips.png"] handler:nil];
#else
		[manager copyPath:[[NSBundle bundleForClass:[self class]] pathForResource:@"snd" ofType:@"gif"] toPath:[[trashFilename stringByDeletingLastPathComponent] stringByAppendingPathComponent:@"snd.gif"] handler:nil];
#endif
		return [[writeString dataUsingEncoding:NSUnicodeStringEncoding] writeToFile:[path stringByAppendingPathComponent:@"index.html"] atomically:flag];
	}
	else
		return NO;
}

- (NSArray *)readFromFile:(NSString *)path
{
	BOOL isDir;
	NSMutableArray *returnArray = [NSMutableArray array];
	NSFileManager *manager = [NSFileManager defaultManager];

	if ((YES == [manager fileExistsAtPath:path isDirectory:&isDir]) && (YES == isDir) && (YES == [manager fileExistsAtPath:[path stringByAppendingPathComponent:@"index.html"]])) {
		NSString *index;
		NSString *rootIndex;
		NSString *name;
		NSString *nameKana;
		NSString *post;
		NSString *country;
		NSString *zip;
		NSString *prefecture;
		NSString *city;
		NSString *town;
		NSString *address;
		NSString *prefectureKana;
		NSString *cityKana;
		NSString *townKana;
		NSString *telNumber;
		NSString *faxNumber;
		NSString *phsNumber;
		NSString *email;
		NSString *url;
		NSString *type;
		NSString *birthDay;
		NSString *others;
		double locateX;
		double locateY;
		double locateZ;
		NSString *pictureFilename;
		NSString *soundFilename;
		Model *aModel;
		NSString *tagString;
		NSRange preRange,sufRange;
		/* 2002-08-02 変更 */
		NSString *readString;
		NSScanner *aScanner;
		NSData *readData = [NSData dataWithContentsOfFile:[path stringByAppendingPathComponent:@"index.html"]];
		NSCharacterSet *spaceSet = [NSCharacterSet characterSetWithCharactersInString:@" "];
		NSString *tabString = @"\t";
		NSString *newlineString = @"\n";
		
		/* 2002-08-02 変更 */
		readString = (YES == [[[readData subdataWithRange:NSMakeRange(0,2)] description] isEqualToString:@"<feff>"]) ? [[NSString alloc] initWithData:readData encoding:NSUnicodeStringEncoding] : [[NSString alloc] initWithData:readData encoding:NSUTF8StringEncoding];
		aScanner = [NSScanner scannerWithString:readString];
		/* タブ・改行はスキップしないで、スペースのみをスキップするように設定する。 */
		[aScanner setCharactersToBeSkipped:spaceSet];
		[aScanner scanUpToString:@"<BODY>\n" intoString:NULL];
		[aScanner scanString:@"<BODY>\n" intoString:NULL];
		while (NO == [aScanner isAtEnd]) {
			/* 先頭がタブかどうかを調べる。 */
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&index];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				index = @"";
			if (YES == [index isEqualToString:@"</BODY>"])
				break;
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&rootIndex];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				rootIndex = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&name];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				name = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&nameKana];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				nameKana = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&post];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				post = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&country];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				country = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&zip];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				zip = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&prefecture];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				prefecture = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&city];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				city = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&town];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				town = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&address];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				address = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&prefectureKana];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				prefectureKana = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&cityKana];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				cityKana = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&townKana];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				townKana = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&telNumber];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				telNumber = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&faxNumber];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				faxNumber = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&phsNumber];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				phsNumber = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&email];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				email = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&url];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				url = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&type];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				type = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&birthDay];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				birthDay = @"";
			if (NO == [aScanner scanString:tabString intoString:NULL]) {
				[aScanner scanUpToString:tabString intoString:&others];
				[aScanner scanString:tabString intoString:NULL];
			}
			else
				others = @"";
			[aScanner scanDouble:&locateX];
			/* タブを読み飛ばす。 */
			[aScanner scanString:tabString intoString:NULL];
			[aScanner scanDouble:&locateY];
			[aScanner scanString:tabString intoString:NULL];
			[aScanner scanDouble:&locateZ];
			[aScanner scanString:tabString intoString:NULL];
			soundFilename = nil;
			pictureFilename = nil;
			do {
				[aScanner scanUpToString:@"<" intoString:NULL];
				[aScanner scanString:@"<" intoString:NULL];
				[aScanner scanUpToString:@">" intoString:&tagString];
				[aScanner scanString:@">" intoString:NULL];
				if (YES == [tagString hasPrefix:@"A HREF="]) {
					preRange = [tagString rangeOfString:@"\"" options:NSLiteralSearch];
					sufRange = [tagString rangeOfString:@"\"" options:NSLiteralSearch | NSBackwardsSearch];
					soundFilename = [tagString substringWithRange:NSMakeRange(preRange.location + 1,sufRange.location - preRange.location - 1)];
					[aScanner scanUpToString:@"</A>" intoString:NULL];
					[aScanner scanString:@"</A>" intoString:NULL];
				}
				if (YES == [tagString hasPrefix:@"IMG SRC="]) {
					preRange = [tagString rangeOfString:@"\"" options:NSLiteralSearch];
					sufRange = [tagString rangeOfString:@"\"" options:NSLiteralSearch | NSBackwardsSearch];
					pictureFilename = [tagString substringWithRange:NSMakeRange(preRange.location + 1,sufRange.location - preRange.location - 1)];
				}
			} while (NO == [tagString isEqualToString:@"BR"]);
			[aScanner scanUpToString:newlineString intoString:NULL];
			[aScanner scanString:newlineString intoString:NULL];
			aModel = [[Model alloc] init];
			[aModel setIndex:index];
			[aModel setRootIndex:rootIndex];
			[aModel setName:name];
			[aModel setNameKana:nameKana];
			[aModel setPost:post];
			[aModel setCountry:country];
			[aModel setZip:zip];
			[aModel setPrefecture:prefecture];
			[aModel setCity:city];
			[aModel setTown:town];
			[aModel setAddress:address];
			[aModel setPrefectureKana:prefectureKana];
			[aModel setCityKana:cityKana];
			[aModel setTownKana:townKana];
			[aModel setTelNumber:telNumber];
			[aModel setFaxNumber:faxNumber];
			[aModel setPhsNumber:phsNumber];
			[aModel setEmail:email];
			[aModel setUrl:url];
			[aModel setType:type];
			[aModel setBirthDay:birthDay];
			[aModel setOthers:others];
			[aModel setLocateX:locateX];
			[aModel setLocateY:locateY];
			[aModel setLocateZ:locateZ];
			if (nil != pictureFilename) {
				[aModel setPicture:[[NSImage alloc] initWithContentsOfFile:[path stringByAppendingPathComponent:pictureFilename]]];
				[aModel setPictureFilename:pictureFilename];
			}
			if (nil != soundFilename) {
#ifdef __APPLE__
				[aModel setSound:[NSData dataWithContentsOfFile:[path stringByAppendingPathComponent:soundFilename]]];
#else
				[aModel setSound:[[Sound alloc] initFromSoundfile:[path stringByAppendingPathComponent:soundFilename]]];
#endif
				[aModel setSoundFilename:soundFilename];
			}
			[returnArray addObject:aModel];
		}
		[readString release];
	}
	return returnArray;
}

- (void)removeModel:(Model *)aModel filename:(NSString *)path
{
	if ((nil != path) && (NO == [path isEqualToString:@""])) {
		NSUInteger i;
		NSString *file;
		NSString *imageFilename = [aModel pictureFilename]; /* 絶対パス・相対パスの両方ともある。 */
		BOOL isDeletable = (YES == [imageFilename hasPrefix:@"/"]) ? NO : YES;
#ifdef __APPLE__
		NSString *soundFilename = [aModel soundFilename];
		BOOL soundIsDeletable = (YES == [soundFilename hasPrefix:@"/"]) ? NO : YES;
#else
		NSString *index = [aModel index];
		NSString *soundFilename = [index stringByAppendingPathExtension:@"snd"];
#endif
		NSFileManager *manager = [NSFileManager defaultManager];
		NSArray *dirContents = [manager directoryContentsAtPath:path];
		NSString *trashFilename = [path stringByAppendingPathComponent:@"images/.trash"];
		NSMutableString *trashString;

		if (NO == [manager fileExistsAtPath:trashFilename]) {
			if (NO == [manager fileExistsAtPath:[trashFilename stringByDeletingLastPathComponent]])
				[manager createDirectoryAtPath:[trashFilename stringByDeletingLastPathComponent] attributes:nil];
			if (NO == [manager fileExistsAtPath:trashFilename])
				[manager createFileAtPath:trashFilename contents:[NSData data] attributes:nil];
		}
		trashString = [NSMutableString stringWithContentsOfFile:trashFilename];
		for (i = 0; i < [dirContents count]; i++) {
			file = [dirContents objectAtIndex:i];
			if ((YES == isDeletable) && (YES == [file isEqualToString:imageFilename]))
				[trashString appendString:[NSString stringWithFormat:@"%@\t",file]];
#ifdef __APPLE__
			if ((YES == soundIsDeletable) && (YES == [file isEqualToString:soundFilename]))
				[trashString appendString:[NSString stringWithFormat:@"%@\t",file]];
#else
			if (YES == [file isEqualToString:soundFilename])
				[trashString appendString:[NSString stringWithFormat:@"%@\t",file]];
#endif
		}
		[[trashString dataUsingEncoding:NSUnicodeStringEncoding] writeToFile:trashFilename atomically:YES];
	}
}

- (NSArray *)revertFromFile:(NSString *)path
{
	if ((nil != path) && (NO == [path isEqualToString:@""])) {
		NSFileManager *manager = [NSFileManager defaultManager];
		NSString *trashFilename = [path stringByAppendingPathComponent:@"images/.trash"];

		if (YES == [manager fileExistsAtPath:trashFilename])
			[manager removeFileAtPath:trashFilename handler:nil];
		return [self readFromFile:path];
	}
	else
		return [NSArray array];
}

- (BOOL)indexChanged:(Model *)oldModel to:(NSString *)newIndex at:(NSString *)path
{
	if ((nil != path) && (NO == [path isEqualToString:@""])) {
		NSUInteger i;
		NSString *file;
		NSFileManager *manager = [NSFileManager defaultManager];
		NSArray *dirContents = [manager directoryContentsAtPath:path];
		NSString *oldIndex = [oldModel index];
		NSString *oldPictureFilename = [oldModel pictureFilename];
#ifdef __APPLE__
		NSString *oldSoundFilename = [oldModel soundFilename];
		NSArray *soundFileTypes = [NSSound soundUnfilteredFileTypes];
#endif

		for (i = 0; i < [dirContents count]; i++) {
			file = [dirContents objectAtIndex:i];
			if ((YES == [[file stringByDeletingPathExtension] isEqualToString:oldIndex]) && (NO == [file isEqualToString:@"index.html"])) {
				/* index.htmlは保存のときに一括して更新されるのでここでは変更を要しない。 */
				if (NO == [manager copyPath:[path stringByAppendingPathComponent:file] toPath:[path stringByAppendingPathComponent:[newIndex stringByAppendingPathExtension:[file pathExtension]]] handler:nil])
					return NO;
				else {
#ifdef __APPLE__
					if ((YES == [soundFileTypes containsObject:[file pathExtension]]) && (NO == [oldSoundFilename hasPrefix:@"/"]))
						[oldModel setSoundFilename:[newIndex stringByAppendingPathExtension:[file pathExtension]]];
					else {
						if (NO == [oldPictureFilename hasPrefix:@"/"])
							[oldModel setPictureFilename:[newIndex stringByAppendingPathExtension:[file pathExtension]]];
					}
#else
					if ((NO == [[file pathExtension] isEqualToString:@"snd"]) && (NO == [oldPictureFilename hasPrefix:@"/"]))
						[oldModel setPictureFilename:[newIndex stringByAppendingPathExtension:[file pathExtension]]];
#endif
				}
			}
		}
		[oldModel setIndex:newIndex];
		return YES;
	}
	else {
		[oldModel setIndex:newIndex];
		return YES;
	}
}

#import "MainDocument.h" /* 2002-07-16 追加 */
- (NSDictionary *)dictionaryWithModels:(NSArray *)anArray
{
	if (nil != anArray) {
		NSUInteger i;
		Model *aModel;
		NSArray *arrayValue;
		NSMutableDictionary *aDic;
		NSMutableDictionary *returnDic = [NSMutableDictionary dictionaryWithCapacity:10];

		for (i = 0; i < [anArray count]; i++) {
			aModel = [anArray objectAtIndex:i];
			aDic = [NSMutableDictionary dictionaryWithObjectsAndKeys:[aModel rootIndex],RootIndexKey,[aModel name],NameKey,[aModel nameKana],NameKanaKey,[aModel post],PostKey,[aModel country],CountryKey,[aModel zip],ZipKey,[aModel prefecture],PrefectureKey,[aModel prefectureKana],PrefectureKanaKey,[aModel city],CityKey,[aModel cityKana],CityKanaKey,[aModel town],TownKey,[aModel townKana],TownKanaKey,[aModel address],AddressKey,[aModel telNumber],TelNumberKey,[aModel faxNumber],FaxNumberKey,[aModel phsNumber],PHSNumberKey,[aModel type],TypeKey,[aModel birthDay],BirthDayKey,[aModel others],OthersKey,[NSNumber numberWithDouble:[aModel locateX]],LocateXKey,[NSNumber numberWithDouble:[aModel locateY]],LocateYKey,[NSNumber numberWithDouble:[aModel locateZ]],LocateZKey,[aModel pictureFilename],PictureFilenameKey,[aModel soundFilename],SoundFilenameKey,nil];
			if (NO == [[aModel email] isEqualToString:@""]) {
				arrayValue = [[aModel email] componentsSeparatedByString:@","];
				[aDic setObject:arrayValue forKey:EmailKey];
			}
			if (NO == [[aModel url] isEqualToString:@""]) {
				arrayValue = [[aModel url] componentsSeparatedByString:@","];
				[aDic setObject:arrayValue forKey:URLNameKey];
			}
			[returnDic setObject:aDic forKey:[aModel index]];
		}
		return returnDic;
	}
	else
		return nil;
}
- (NSDictionary *)fileWrapperDictionary:(NSString *)source enroll:(NSMutableDictionary *)dic
// dicにnilが来ることは無い。 //
{
	NSUInteger i,j;
	NSString *filename;
	NSFileWrapper *fileWrapper;
	NSString *index,*extension;
	NSArray *tempArray;
	NSMutableDictionary *aModel;
	NSString *stringValue;
	double numberValue;
	NSMutableDictionary *fileWrappersDic = [NSMutableDictionary dictionary];
	NSArray *indexes = [dic allKeys];
	NSString *selfFilename = source;
	NSMutableString *writeString = [NSMutableString string];
	NSString *empty = @"";

	[writeString appendFormat:@"<html>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n<head>\n<title>%@</title>\n</head>\n<BODY>\n",[[selfFilename lastPathComponent] stringByDeletingPathExtension]];
	for (i = 0; i < [indexes count]; i++) {
		index = [indexes objectAtIndex:i];
		aModel = [dic objectForKey:index];
		[writeString appendFormat:@"%@",index];
		stringValue = (nil != [aModel objectForKey:RootIndexKey]) ? [aModel objectForKey:RootIndexKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:NameKey]) ? [aModel objectForKey:NameKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:NameKanaKey]) ? [aModel objectForKey:NameKanaKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:PostKey]) ? [aModel objectForKey:PostKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:CountryKey]) ? [aModel objectForKey:CountryKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:ZipKey]) ? [aModel objectForKey:ZipKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:PrefectureKey]) ? [aModel objectForKey:PrefectureKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:CityKey]) ? [aModel objectForKey:CityKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:TownKey]) ? [aModel objectForKey:TownKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:AddressKey]) ? [aModel objectForKey:AddressKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:PrefectureKanaKey]) ? [aModel objectForKey:PrefectureKanaKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:CityKanaKey]) ? [aModel objectForKey:CityKanaKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:TownKanaKey]) ? [aModel objectForKey:TownKanaKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:TelNumberKey]) ? [aModel objectForKey:TelNumberKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:FaxNumberKey]) ? [aModel objectForKey:FaxNumberKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:PHSNumberKey]) ? [aModel objectForKey:PHSNumberKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];		
		tempArray = [aModel objectForKey:EmailKey];
		if ((nil != tempArray) && (0 < [tempArray count])) {
			[writeString appendString:@"\t"];
			for (j = 0; j < [tempArray count]; j++) {
				if (0 < j)
					[writeString appendString:@","];
				[writeString appendString:[tempArray objectAtIndex:j]];
			}
		}
		else
			[writeString appendString:@"\t"];
		tempArray = [aModel objectForKey:URLNameKey];
		if ((nil != tempArray) && (0 < [tempArray count])) {
			[writeString appendString:@"\t"];
			for (j = 0; j < [tempArray count]; j++) {
				if (0 < j)
					[writeString appendString:@","];
				[writeString appendString:[tempArray objectAtIndex:j]];
			}
		}
		else
			[writeString appendString:@"\t"];
		stringValue = (nil != [aModel objectForKey:TypeKey]) ? [aModel objectForKey:TypeKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:BirthDayKey]) ? [aModel objectForKey:BirthDayKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		stringValue = (nil != [aModel objectForKey:OthersKey]) ? [aModel objectForKey:OthersKey] : empty;
		[writeString appendFormat:@"\t%@",stringValue];
		numberValue = (nil != [aModel objectForKey:LocateXKey]) ? [[aModel objectForKey:LocateXKey] doubleValue] : 2.0 * RADIUSOFGRS80;
		[writeString appendFormat:@"\t%g",numberValue];
		numberValue = (nil != [aModel objectForKey:LocateYKey]) ? [[aModel objectForKey:LocateYKey] doubleValue] : 2.0 * RADIUSOFGRS80;
		[writeString appendFormat:@"\t%g",numberValue];
		numberValue = (nil != [aModel objectForKey:LocateZKey]) ? [[aModel objectForKey:LocateZKey] doubleValue] : 2.0 * RADIUSOFGRS80;
		[writeString appendFormat:@"\t%g",numberValue];
		[writeString appendString:@"\t"];
		filename = [aModel objectForKey:PictureFilenameKey];
		if ((nil != filename) && (NO == [filename isEqualToString:@""])) {
			extension = [filename pathExtension];
			if (YES == [filename isAbsolutePath]) {
				if (nil != (fileWrapper = [[NSFileWrapper allocWithZone:[self zone]] initRegularFileWithContents:[NSData dataWithContentsOfFile:filename]])) {
					[fileWrappersDic setObject:fileWrapper forKey:[index stringByAppendingPathExtension:extension]];
					[fileWrapper release];
					[aModel setObject:[index stringByAppendingPathExtension:extension] forKey:PictureFilenameKey];
				}
				else
					[aModel removeObjectForKey:PictureFilenameKey];
			}
			else {
				if (NO == [[filename stringByDeletingPathExtension] isEqualToString:index]) {
					if (nil != (fileWrapper = [[NSFileWrapper allocWithZone:[self zone]] initRegularFileWithContents:[NSData dataWithContentsOfFile:[selfFilename stringByAppendingPathComponent:filename]]])) {
						[fileWrappersDic setObject:fileWrapper forKey:[index stringByAppendingPathExtension:extension]];
						[fileWrapper release];
						[aModel setObject:[index stringByAppendingPathExtension:extension] forKey:PictureFilenameKey];
						
					}
					else
						[aModel removeObjectForKey:PictureFilenameKey];
				}
				else {
					if (nil != (fileWrapper = [[NSFileWrapper allocWithZone:[self zone]] initRegularFileWithContents:[NSData dataWithContentsOfFile:[selfFilename stringByAppendingPathComponent:filename]]])) {
						[fileWrappersDic setObject:fileWrapper forKey:[index stringByAppendingPathExtension:extension]];
						[fileWrapper release];
					}
					else
						[aModel removeObjectForKey:PictureFilenameKey];
				}
			}
		}
		if ((nil != (filename = [aModel objectForKey:PictureFilenameKey])) && (NO == [filename isEqualToString:@""]))
			[writeString appendFormat:@"<IMG SRC=\"%@\">",filename];
		
		filename = [aModel objectForKey:SoundFilenameKey];
		if ((nil != filename) && (NO == [filename isEqualToString:@""])) {
			extension = [filename pathExtension];
			if (YES == [filename isAbsolutePath]) {
				if (nil != (fileWrapper = [[NSFileWrapper allocWithZone:[self zone]] initRegularFileWithContents:[NSData dataWithContentsOfFile:filename]])) {
					[fileWrappersDic setObject:fileWrapper forKey:[index stringByAppendingPathExtension:extension]];
					[fileWrapper release];
					[aModel setObject:[index stringByAppendingPathExtension:extension] forKey:SoundFilenameKey];
				}
				else
					[aModel removeObjectForKey:SoundFilenameKey];
			}
			else {
				if (NO == [[filename stringByDeletingPathExtension] isEqualToString:index]) {
					if (nil != (fileWrapper = [[NSFileWrapper allocWithZone:[self zone]] initRegularFileWithContents:[NSData dataWithContentsOfFile:[selfFilename stringByAppendingPathComponent:filename]]])) {
						[fileWrappersDic setObject:fileWrapper forKey:[index stringByAppendingPathExtension:extension]];
						[fileWrapper release];
						[aModel setObject:[index stringByAppendingPathExtension:extension] forKey:SoundFilenameKey];
						
					}
					else
						[aModel removeObjectForKey:SoundFilenameKey];
				}
				else {
					if (nil != (fileWrapper = [[NSFileWrapper allocWithZone:[self zone]] initRegularFileWithContents:[NSData dataWithContentsOfFile:[selfFilename stringByAppendingPathComponent:filename]]])) {
						[fileWrappersDic setObject:fileWrapper forKey:[index stringByAppendingPathExtension:extension]];
						[fileWrapper release];
					}
					else
						[aModel removeObjectForKey:SoundFilenameKey];
				}
			}
		}
		if ((nil != (filename = [aModel objectForKey:SoundFilenameKey])) && (NO == [filename isEqualToString:@""]))
			[writeString appendFormat:@"<A HREF=\"%@\"><IMG SRC=\"images/lips.png\"></A>",filename];
		[writeString appendString:@"<BR>\n"];
	}
	[writeString appendString:@"</BODY>\t\n</html>\n"];
	if (nil != (fileWrapper = [[NSFileWrapper allocWithZone:[self zone]] initRegularFileWithContents:[NSData dataWithContentsOfFile:[[NSBundle bundleForClass:[self class]] pathForResource:@"lips" ofType:@"png"]]])) {
		NSString *inDirectoryFilename = @"lips.png";
		NSDictionary *inDirectoryFileWrapper = [NSDictionary dictionaryWithObject:fileWrapper forKey:inDirectoryFilename];

		[fileWrapper release];
		if (nil != (fileWrapper = [[NSFileWrapper allocWithZone:[self zone]] initDirectoryWithFileWrappers:inDirectoryFileWrapper])) {
			filename = [NSString stringWithString:@"images"];
			[fileWrappersDic setObject:fileWrapper forKey:filename];
			[fileWrapper release];
		}
	}
	if (nil != (fileWrapper = [[NSFileWrapper allocWithZone:[self zone]] initRegularFileWithContents:[writeString dataUsingEncoding:NSUTF8StringEncoding]])) {
		filename = [NSString stringWithString:@"index.html"];
		[fileWrappersDic setObject:fileWrapper forKey:filename];
		[fileWrapper release];
		return fileWrappersDic;
	}
	else
		return nil;
}

@end
