//
//  MainDocument.h
//  «PROJECTNAME»
//
//  Created by SatoAkira on «DATE».
//  Copyright (c) 2002 SatoAkira. All rights reserved.
//


#import <Cocoa/Cocoa.h>
#import "MainWindowController.h"

@interface MainDocument : NSDocument
{
	MainWindowController *windowController;
	NSDictionary *enrollDictionary;
	NSMutableDictionary *namesDictionary;
	NSFileWrapper *imagesWrapper;
	NSFileWrapper *soundsWrapper;
}

- (MainWindowController *)windowController;
- (NSDictionary *)enrollDictionary;
- (NSArray *)indexes;
- (NSString *)nameAtNumber:(NSUInteger)number;
- (NSArray *)names;
- (NSUInteger)numberOfName:(NSString *)aString;
- (NSArray *)modelOfName:(NSString *)aString;
- (NSDictionary *)namesDictionary;
- (NSString *)reverseLocalizedString:(NSString *)aString;
- (BOOL)changeIndex:(NSString *)oldIndex to:(NSString *)newIndex;
- (BOOL)addModel:(NSDictionary *)aValue picture:(NSURL *)imageURL pictureData:(NSData *)pData sound:(NSURL *)soundURL soundData:(NSData *)sData forKey:(NSString *)index;
- (BOOL)deleteIndex:(NSString *)oldIndex;
- (NSDictionary *)selfDictionary;

extern NSString *IndexKey;
extern NSString *RootIndexKey;
extern NSString *NameKey;
extern NSString *NameKanaKey;
extern NSString *PostKey;
extern NSString *CountryKey;
extern NSString *ZipKey;
extern NSString *PrefectureKey;
extern NSString *PrefectureKanaKey;
extern NSString *CityKey;
extern NSString *CityKanaKey;
extern NSString *TownKey;
extern NSString *TownKanaKey;
extern NSString *AddressKey;
extern NSString *TelNumberKey;
extern NSString *FaxNumberKey;
extern NSString *PHSNumberKey;
extern NSString *EmailKey;
extern NSString *URLNameKey;
extern NSString *TypeKey;
extern NSString *BirthDayKey;
extern NSString *OthersKey;
extern NSString *LocateXKey;
extern NSString *LocateYKey;
extern NSString *LocateZKey;
extern NSString *ImagesFileNameKey;
extern NSString *SoundsFileNameKey;
extern NSString *EnrollImagesWrapperKey;
extern NSString *EnrollSoundsWrapperKey;
extern NSString *ModelKey;
extern NSString *IndexDidChangeNotification;
extern NSString *ContextDidChangeNotification;
extern NSString *MailToDidChangeNotification;

@end
