/* Model.h created by SatoAkira on Sat 26-Jun-1999 */

#import <AppKit/AppKit.h>
#ifndef __APPLE__
#import <SoundKit/Sound.h>
/* #import <SoundKit/SoundMeter.h>
#import <SoundKit/SoundView.h> */
#endif

@interface Model : NSObject <NSCoding>
{
	NSString *index;
	NSString *rootIndex;	// ここで会社との関連付けを定義する。プログラムから会社名などを引っ張り出す。 //
	NSString *name;
	NSString *nameKana;
	NSString *post;
	NSString *country;
	NSString *zip;
	NSString *prefecture;
	NSString *city;
	NSString *town;
	NSString *address;
	NSString *prefectureKana;
	NSString *cityKana;
	NSString *townKana;
	NSString *telNumber;
	NSString *faxNumber;
	NSString *phsNumber;
	NSString *email;
	NSString *url;
	NSString *type;
	NSString *birthDay;
	NSString *others;	// NSTextViewからRTFDを取ると、改行コードなども含まれてしまうのでNSTextFieldの値とする。 //
	double locateX;
	double locateY;
	double locateZ;
	NSImage *picture;
	NSString *pictureFilename;
#ifdef __APPLE__
	NSData *sound;
#else
	Sound *sound;
#endif
	NSString *soundFilename;
}

- (id)init;
- (void)dealloc;
- (id)initWithCoder:(NSCoder *)coder;
- (void)encodeWithCoder:(NSCoder *)coder;
- (void)setIndex:(NSString *)aString;
- (void)setRootIndex:(NSString *)aString;
- (void)setName:(NSString *)aString;
- (void)setNameKana:(NSString *)aString;
- (void)setPost:(NSString *)aString;
- (void)setCountry:(NSString *)aString;
- (void)setZip:(NSString *)aString;
- (void)setPrefecture:(NSString *)aString;
- (void)setCity:(NSString *)aString;
- (void)setTown:(NSString *)aString;
- (void)setAddress:(NSString *)aString;
- (void)setPrefectureKana:(NSString *)aString;
- (void)setCityKana:(NSString *)aString;
- (void)setTownKana:(NSString *)aString;
- (void)setTelNumber:(NSString *)aString;
- (void)setFaxNumber:(NSString *)aString;
- (void)setPhsNumber:(NSString *)aString;
- (void)setEmail:(NSString *)aString;
- (void)setUrl:(NSString *)aString;
- (void)setType:(NSString *)aString;
- (void)setBirthDay:(NSString *)aString;
- (void)setOthers:(NSString *)aString;
- (void)setLocateX:(double)aValue;
- (void)setLocateY:(double)aValue;
- (void)setLocateZ:(double)aValue;
- (void)setPicture:(NSImage *)aImage;
- (void)setPictureFilename:(NSString *)aString;
#ifdef __APPLE__
- (void)setSound:(NSData *)aSound;
#else
- (void)setSound:(Sound *)aSound;
#endif
- (void)setSoundFilename:(NSString *)aString;
- (NSString *)index;
- (NSString *)rootIndex;
- (NSString *)name;
- (NSString *)nameKana;
- (NSString *)post;
- (NSString *)country;
- (NSString *)zip;
- (NSString *)prefecture;
- (NSString *)city;
- (NSString *)town;
- (NSString *)address;
- (NSString *)prefectureKana;
- (NSString *)cityKana;
- (NSString *)townKana;
- (NSString *)telNumber;
- (NSString *)faxNumber;
- (NSString *)phsNumber;
- (NSString *)email;
- (NSString *)url;
- (NSString *)type;
- (NSString *)birthDay;
- (NSString *)others;
- (double)locateX;
- (double)locateY;
- (double)locateZ;
- (NSImage *)picture;
- (NSString *)pictureFilename;
#ifdef __APPLE__
- (NSData *)sound;
#else
- (Sound *)sound;
#endif
- (NSString *)soundFilename;
- (NSInteger)nameCompare:(Model *)otherModel;
- (NSInteger)addressCompare:(Model *)otherModel;
- (NSInteger)typeCompare:(Model *)otherModel;
- (NSInteger)birthDayCompare:(Model *)otherModel;
#define RADIUSOFGRS80 6378137.00	/* GRS80の長半径 */

@end
