/* PostalFind.h created by me on Wed 30-Jun-1999 */

#import <AppKit/AppKit.h>
#import "PostalDictionaryServerProtocol.h"

@interface PostalFind : NSObject
{
	id theProxy;
	id delegate;
	NSString *registeredName;
	NSString *separator;
	NSString *otherTown;
}

+ (PostalFind *)postalFind;
- (id)init;
- (void)dealloc;
- (BOOL)postalSet;
- (void)connectionDidDie:(NSNotification *)notification;
- (void)connectionDidInitialize:(NSNotification *)notification;
- (void)setDelegate:(id)anObject;
- (NSArray *)findWithZip:(NSString *)code;
- (NSArray *)findWithPrefecture:(NSString *)prefecture City:(NSString *)city Town:(NSString *)town;
- (NSArray *)findWithCompany:(NSString *)name;
- (NSString *)registeredName;
- (NSString *)separator;
- (NSString *)otherTown;
- (id)postalProxy;
- (id)delegate;
- (NSString *)dictionaryName;
- (NSString *)dictionaryDate;
- (NSDictionary *)workingPrefectures;
- (NSDictionary *)enablePrefectures;
- (NSUInteger)setPrefectures:(NSArray *)prefectures;

@end

@interface NSObject (PostalFindDelegate)

- (void)postalDidDie:(id)sender;
- (void)postalDidInitialize:(id)sender;

@end
